SystemOrganization addCategory: #'Frank-Core'!

WARequestHandler subclass: #FSRequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Frank-Core'!

!FSRequestHandler methodsFor: 'handling' stamp: 'pmm 7/9/2012 21:15'!
handleFiltered: aRequestContext
	aRequestContext consumer atEnd
		ifTrue: [ self listing: aRequestContext ]
		ifFalse: [ self receive: aRequestContext ]! !

!FSRequestHandler methodsFor: 'private' stamp: 'pmm 8/3/2012 07:43'!
handleSelector: aSymbol context: aRequestContext
	| content |
	content := [ self perform: aSymbol ]
		on: Error
		do: [ :error | 
			^ aRequestContext responseGenerator
					internalError: error;
					respond ].
			
	aRequestContext respond: [ :response | 
		response
			contentType: WAMimeType textHtml;
			nextPutAll: content ]! !

!FSRequestHandler methodsFor: 'routes' stamp: 'pmm 7/9/2012 21:26'!
index
	^ ''! !

!FSRequestHandler methodsFor: 'private' stamp: 'pmm 7/9/2012 21:26'!
listing: aRequestContext
	self handleSelector: #index context: aRequestContext! !

!FSRequestHandler methodsFor: 'private' stamp: 'pmm 7/27/2012 21:45'!
receive: aRequestContext
	| selector |
	selector := aRequestContext consumer next asSymbol.
	(selector isUnary and: [ (self respondsTo: selector) ])
		ifTrue: [
			self handleSelector: selector context: aRequestContext ]
		ifFalse: [
			aRequestContext responseGenerator
				notFound;
				respond ] ! !
